<template>
  <div class="dialog-box" style="position: relative">
    <el-scrollbar class="custom-scroll content-box">
      <el-form
        ref="formEditRestaurantFoodType"
        :model="formData"
        :size="layoutStore.defaultFormItemSize"
        :rules="rules"
        label-width="120px"
        label-position="right"
        @submit.prevent
      >
        <el-row :gutter="16">
          <el-col :span="14">
            <el-form-item label="选择餐馆" prop="RestaurantFoodType.restaurantId">
              <el-select
                class="input-item"
                v-model="formData.RestaurantFoodType.restaurantId"
                placeholder=""
                :clearable="true"
                :filterable="true"
                @visible-change="restaurantIdWidget.onVisibleChange"
              >
                <el-option
                  v-for="item in restaurantIdWidgetDropdownList"
                  :key="item.id"
                  :label="item.name"
                  :value="item.id"
                />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="14">
            <el-form-item label="种类名称" prop="RestaurantFoodType.name">
              <el-input
                class="input-item"
                v-model="formData.RestaurantFoodType.name"
                type="text"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
          <el-col :span="14">
            <el-form-item label="是否启用" prop="RestaurantFoodType.enable">
              <el-radio-group
                class="input-item"
                v-model="formData.RestaurantFoodType.enable"
              >
                <el-radio
                  v-for="item in enableWidgetDropdownList"
                  :key="item.id"
                  :label="item.id"
                >
                  {{ item.name }}
                </el-radio>
              </el-radio-group>
            </el-form-item>
          </el-col>
          <el-col :span="14">
            <el-form-item label="显示顺序" prop="RestaurantFoodType.showOrder">
              <el-input-number
                class="input-item"
                v-model="formData.RestaurantFoodType.showOrder"
                placeholder=""
                :clearable="true"
                :step="1"
                :controls="true"
              />
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="描述" prop="RestaurantFoodType.description">
              <el-input
                class="input-item"
                v-model="formData.RestaurantFoodType.description"
                type="textarea"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
    </el-scrollbar>
    <el-row class="footer-box" type="flex" justify="end" align="middle">
      <el-button :size="layoutStore.defaultFormItemSize" @click="onCancel()">取消</el-button>
      <el-button :size="layoutStore.defaultFormItemSize" type="primary" @click="onSaveClick()">保存</el-button>
    </el-row>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formEditRestaurantFoodType',
};
</script>

<script setup lang="ts">
import { DialogProp } from '@/components/Dialog/types';
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode } from '@/common/utils';
import { RestaurantFoodTypeData } from '@/api/generated/restaurantFoodTypeController';
import { RestaurantFoodTypeController } from '@/api/generated';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const { 
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
    id?: ANY_OBJECT;
    saveOnSubmit?: boolean;
    rowData?: ANY_OBJECT;
    // 当使用Dialog.show弹出组件时，须定义该prop属性，以便对dialog进行回调
    dialog?: DialogProp<ANY_OBJECT[]>;
  }>(),
  {
    subPage: 0,
    id: undefined,
    saveOnSubmit: true,
    rowData: undefined,
    dialog: undefined,
  },
);

const formEditRestaurantFoodType = ref();
// 表单数据定义
type FormEditRestaurantFoodTypeData = {
  RestaurantFoodType: RestaurantFoodTypeData;
};
// 表单数据
const formData = reactive<FormEditRestaurantFoodTypeData>({
  RestaurantFoodType: {
    // 主键id
    id: undefined,
    // 种类名称
    name: undefined,
    // 餐馆id
    restaurantId: undefined,
    // 是否启用，0禁用，1启用
    enable: undefined,
    // 显示顺序
    showOrder: undefined,
    // 描述
    description: undefined,
    // 创建用户
    createUserId: undefined,
    // 创建时间
    createTime: undefined,
    // 更新用户
    updateUserId: undefined,
    // 更新时间
    updateTime: undefined,
    // 删除标记(1: 正常 -1: 已删除)
    dataState: undefined,
  },
},
);
// 表单验证规则
const rules = reactive({
  'RestaurantFoodType.restaurantId': [
    {required: true, message: '请输入选择餐馆', trigger: 'blur'}
  ],
  'RestaurantFoodType.enable': [
    {required: true, message: '请输入是否启用', trigger: 'blur'}
  ],
  'RestaurantFoodType.name': [
    {required: true, message: '请输入种类名称', trigger: 'blur'}
  ],
  'RestaurantFoodType.description': [
  ],
  'RestaurantFoodType.showOrder': [
    {required: true, message: '请输入显示顺序', trigger: 'blur'}
  ],
});

const onCancel = () => {
  if (props.dialog) {
    props.dialog.cancel();
  }
};

const isEdit = computed(() => {
  return props.saveOnSubmit ? props.id != null : props.rowData != null;
});

// 初始化页面数据
const loadRestaurantFoodTypeData = () => {
  return new Promise<void>((resolve, reject) => {
    if (!isEdit.value) {
      resolve();
      return;
    }
    if (!props.saveOnSubmit && props.rowData != null) {
      formData.RestaurantFoodType = JSON.parse(JSON.stringify(props.rowData));
      resolve();
      return;
    }
    let params: ANY_OBJECT = {
      id: props.id
    };
    RestaurantFoodTypeController.view(params).then(res => {
      formData.RestaurantFoodType = { ...res.data };
      resolve();
    }).catch(e => {
      reject(e);
    });
  });
};
/**
 * 选择餐馆下拉数据获取函数
 */
const loadRestaurantIdDropdownList = (): Promise<ListData<DictData>> => {
  return new Promise((resolve, reject) => {
    const params = {
    };
    DictionaryController.dictRestaurantInfo(params).then(res => {
      resolve({
        dataList: res.getList(),
      });
    }).catch(e => {
      reject(e);
    });
  });
};
// 选择餐馆配置参数
const restaurantIdOptions: DropdownOptions<DictData> = {
  loadData: loadRestaurantIdDropdownList,
  isTree: false,
};
// 选择餐馆下拉组件
const restaurantIdWidget = useDropdown(restaurantIdOptions);
const { dropdownList: restaurantIdWidgetDropdownList } = restaurantIdWidget
/**
 * 是否启用下拉数据获取函数
 */
const loadEnableDropdownList = (): Promise<ListData<DictData>> => {
  return Promise.resolve({
    dataList: StaticDict.Enable.getList(),
  });
};
// 是否启用配置参数
const enableOptions: DropdownOptions<DictData> = {
  loadData: loadEnableDropdownList,
  isTree: false,
};
// 是否启用下拉组件
const enableWidget = useDropdown(enableOptions);
const { dropdownList: enableWidgetDropdownList } = enableWidget
const onUploadError = () => {
  ElMessage.error('文件上传失败');
};
const onUploadLimit = () => {
  ElMessage.error('已经超出最大上传个数限制');
};
const refreshFormEditRestaurantFoodType = () => {
  // 刷新段落
};
/**
 * 重置过滤值
 */
const resetFormEditRestaurantFoodType = () => {
  refreshFormEditRestaurantFoodType();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormEditRestaurantFoodType();
};
/**
 * 保存
 */
const onSaveClick = () => {
  formEditRestaurantFoodType.value.validate((valid) => {
    if (!valid) return;
    // 级联操作
    if (!props.saveOnSubmit) {
      let formData = {
        ...formData.RestaurantFoodType
      };
    formData.restaurantIdDictMap = findItemFromList(restaurantIdWidgetDropdownList, formData.restaurantId, 'id');
    formData.enableDictMap = findItemFromList(enableWidgetDropdownList, formData.enable, 'id');
  props.dialog?.submit(formData);
      return;
    }
    let params: ANY_OBJECT = {
      restaurantFoodTypeDto: {
        id: formData.RestaurantFoodType.id,
        restaurantId: formData.RestaurantFoodType.restaurantId,
        name: formData.RestaurantFoodType.name,
        enable: formData.RestaurantFoodType.enable,
        showOrder: formData.RestaurantFoodType.showOrder,
        description: formData.RestaurantFoodType.description,
        createUserId: formData.RestaurantFoodType.createUserId,
        createTime: formData.RestaurantFoodType.createTime,
        updateUserId: formData.RestaurantFoodType.updateUserId,
        updateTime: formData.RestaurantFoodType.updateTime,
      }
    };

    let httpCall = isEdit.value ? RestaurantFoodTypeController.update : RestaurantFoodTypeController.add;
    httpCall(params).then(res => {
      ElMessage.success('保存成功');
      props.dialog?.submit();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
  });
};
const formInit = () => {
  loadRestaurantFoodTypeData().then(res => {
    restaurantIdWidget.onVisibleChange(true).catch(e => {console.error(e)});
    enableWidget.onVisibleChange(true).catch(e => {console.error(e)});
    if (isEdit.value) refreshFormEditRestaurantFoodType();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};

onMounted(() => {
  formInit();
});
</script>
